Package org.apache.catalina.connector

## Class Request

- java.lang.Object
- - org.apache.catalina.connector.Request

All Implemented Interfaces:
  `HttpServletRequest`, `ServletRequest`

    public class Request
    extends java.lang.Object
    implements HttpServletRequest

Wrapper object for the Coyote request.

Author:
  Remy Maucherat, Craig R. McClanahan

### Field Summary

Fields
`protected java.lang.Boolean` `asyncSupported`
`protected java.lang.String` `authType` Authentication type.
`protected static int` `CACHED_POST_LEN` Post data buffer.
`protected Connector` `connector` Associated Catalina connector.
`protected Cookie[]` `cookies` The set of cookies associated with this Request.
`protected boolean` `cookiesConverted` Cookie parsed flag.
`protected boolean` `cookiesParsed` Cookie headers parsed flag.
`protected Request` `coyoteRequest` Coyote request.
`protected static java.util.Locale` `defaultLocale` The default Locale if none are specified.
`protected RequestFacade` `facade` The facade associated with this request.
`protected FilterChain` `filterChain` Filter chain associated with the request.
`protected java.text.SimpleDateFormat[]` `formats` Deprecated. Unused.
`protected static java.util.TimeZone` `GMT_ZONE` Deprecated. Unused.
`protected InputBuffer` `inputBuffer` The associated input buffer.
`protected CoyoteInputStream` `inputStream` ServletInputStream.
`protected DispatcherType` `internalDispatcherType` The current dispatcher type.
`protected java.lang.String` `localAddr` Local address
`protected java.util.ArrayList<java.util.Locale>` `locales` The preferred Locales associated with this Request.
`protected boolean` `localesParsed` Parse locales.
`protected java.lang.String` `localName` Local address
`protected int` `localPort` Local port
`protected MappingData` `mappingData` Mapping data.
`protected ParameterMap<java.lang.String,​java.lang.String[]>` `parameterMap` Hash map used in the getParametersMap method.
`protected boolean` `parametersParsed` Request parameters parsed flag.
`protected java.util.Collection<Part>` `parts` The parts, if any, uploaded with this request.
`protected java.lang.Exception` `partsParseException` The exception thrown, if any when parsing the parts.
`protected java.lang.String` `peerAddr` Connection peer address.
`protected byte[]` `postData`
`protected CoyoteReader` `reader` Reader.
`protected java.lang.String` `remoteAddr` Remote address.
`protected java.lang.String` `remoteHost` Remote host.
`protected int` `remotePort` Remote port
`protected java.lang.Object` `requestDispatcherPath` The current request dispatcher path.
`protected boolean` `requestedSessionCookie` Was the requested session ID received in a cookie?
`protected java.lang.String` `requestedSessionId` The requested session ID (if any) for this request.
`protected boolean` `requestedSessionSSL` Was the requested session ID obtained from the SSL session?
`protected boolean` `requestedSessionURL` Was the requested session ID received in a URL?
`protected Response` `response` The response with which this request is associated.
`protected boolean` `secure` Secure flag.
`protected Session` `session` The currently active session for this request.
`protected static StringManager` `sm` The string manager for this package.
`protected boolean` `sslAttributesParsed` Flag that indicates if SSL attributes have been parsed to improve performance for applications (usually frameworks) that make multiple calls to `getAttributeNames()`.
`protected javax.security.auth.Subject` `subject` The Subject associated with the current AccessControlContext
`protected B2CConverter` `URIConverter` URI byte to char converter.
`protected java.security.Principal` `userPrincipal` User principal.
`protected boolean` `usingInputStream` Using stream flag.
`protected boolean` `usingReader` Using reader flag.

### Fields inherited from interface javax.servlet.http.HttpServletRequest

`BASIC_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH, FORM_AUTH`

### Constructor Summary

Constructors
`Request()`

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`void` `addCookie​(Cookie cookie)` Add a Cookie to the set of Cookies associated with this Request.
`void` `addLocale​(java.util.Locale locale)` Add a Locale to the set of preferred Locales for this Request.
`protected void` `addPathParameter​(java.lang.String name, java.lang.String value)`
`boolean` `authenticate​(HttpServletResponse response)` Triggers the same authentication process as would be triggered if the request is for a resource that is protected by a security constraint.
`java.lang.String` `changeSessionId()` Changes the session ID of the session associated with this request.
`void` `changeSessionId​(java.lang.String newSessionId)` Change the ID of the session that this request is associated with.
`protected void` `checkSwallowInput()` Check the configuration for aborted uploads and if configured to do so, disable the swallowing of any remaining input and close the connection once the response has been written.
`void` `clearCookies()` Clear the collection of Cookies associated with this Request.
`void` `clearLocales()` Clear the collection of Locales associated with this Request.
`protected void` `convertCookies()` Converts the parsed cookies (parsing the Cookie headers first if they have not been parsed) into Cookie objects.
`ServletInputStream` `createInputStream()` Create and return a ServletInputStream to read the content associated with this Request.
`protected Session` `doGetSession​(boolean create)`
`void` `finishRequest()` Perform whatever actions are required to flush and close the input stream or reader, in a single operation.
`AsyncContext` `getAsyncContext()` Get the current AsyncContext.
`AsyncContextImpl` `getAsyncContextInternal()`
`java.lang.Object` `getAttribute​(java.lang.String name)` Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.
`java.util.Enumeration<java.lang.String>` `getAttributeNames()` Return the names of all request attributes for this Request, or an empty `Enumeration` if there are none.
`java.lang.String` `getAuthType()` Return the authentication type used for this Request.
`java.lang.String` `getCharacterEncoding()` Returns the name of the character encoding used in the body of this request.
`Connector` `getConnector()`
`int` `getContentLength()` Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known.
`long` `getContentLengthLong()` Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known.
`java.lang.String` `getContentType()` Returns the MIME type of the body of the request, or `null` if the type is not known.
`Context` `getContext()` Return the Context within which this Request is being processed.
`java.lang.String` `getContextPath()` Return the portion of the request URI used to select the Context of the Request.
`Cookie[]` `getCookies()` Return the set of Cookies received with this Request.
`Request` `getCoyoteRequest()` Get the Coyote request.
`long` `getDateHeader​(java.lang.String name)` Return the value of the specified date header, if any; otherwise return -1.
`java.lang.String` `getDecodedRequestURI()` Get the decoded request URI.
`MessageBytes` `getDecodedRequestURIMB()` Get the decoded request URI.
`boolean` `getDiscardFacades()` Get the recycling strategy of the facade objects.
`DispatcherType` `getDispatcherType()`
`FilterChain` `getFilterChain()` Get filter chain associated with the request.
`java.lang.String` `getHeader​(java.lang.String name)` Return the first value of the specified header, if any; otherwise, return `null`
`java.util.Enumeration<java.lang.String>` `getHeaderNames()` Returns an enumeration of all the header names this request contains.
`java.util.Enumeration<java.lang.String>` `getHeaders​(java.lang.String name)` Return all of the values of the specified header, if any; otherwise, return an empty enumeration.
`Host` `getHost()`
`ApplicationMappingImpl` `getHttpServletMapping()`
`ServletInputStream` `getInputStream()` Retrieves the body of the request as binary data using a `ServletInputStream`.
`int` `getIntHeader​(java.lang.String name)` Return the value of the specified header as an integer, or -1 if there is no such header for this request.
`java.lang.String` `getLocalAddr()` Returns the Internet Protocol (IP) address of the interface on which the request was received.
`java.util.Locale` `getLocale()` Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header.
`java.util.Enumeration<java.util.Locale>` `getLocales()` Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header.
`java.lang.String` `getLocalName()` Returns the host name of the Internet Protocol (IP) interface on which the request was received.
`int` `getLocalPort()` Returns the Internet Protocol (IP) port number of the interface on which the request was received.
`MappingData` `getMappingData()`
`java.lang.String` `getMethod()` Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT.
`java.lang.Object` `getNote​(java.lang.String name)`
`java.lang.String` `getParameter​(java.lang.String name)` Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist.
`java.util.Map<java.lang.String,​java.lang.String[]>` `getParameterMap()` Returns a `Map` of the parameters of this request.
`java.util.Enumeration<java.lang.String>` `getParameterNames()` Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request.
`java.lang.String[]` `getParameterValues​(java.lang.String name)` Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.
`Part` `getPart​(java.lang.String name)` Gets the named Part or null if the Part does not exist.
`java.util.Collection<Part>` `getParts()` Return a collection of all uploaded Parts.
`java.lang.String` `getPathInfo()` Returns any extra path information associated with the URL the client sent when it made this request.
`protected java.lang.String` `getPathParameter​(java.lang.String name)`
`java.lang.String` `getPathTranslated()` Returns any extra path information after the servlet name but before the query string, and translates it to a real path.
`java.lang.String` `getPeerAddr()`
`java.security.Principal` `getPrincipal()`
`java.lang.String` `getProtocol()` Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1.
`java.lang.String` `getQueryString()` Returns the query string that is contained in the request URL after the path.
`java.io.BufferedReader` `getReader()` Read the Reader wrapping the input stream for this Request.
`java.lang.String` `getRealPath​(java.lang.String path)` Deprecated. As of version 2.1 of the Java Servlet API, use `ServletContext.getRealPath()`.
`java.lang.String` `getRemoteAddr()` Returns the Internet Protocol (IP) address of the client or last proxy that sent the request.
`java.lang.String` `getRemoteHost()` Returns the fully qualified name of the client or the last proxy that sent the request.
`int` `getRemotePort()` Returns the Internet Protocol (IP) source port of the client or last proxy that sent the request.
`java.lang.String` `getRemoteUser()` Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated.
`HttpServletRequest` `getRequest()`
`RequestDispatcher` `getRequestDispatcher​(java.lang.String path)` Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path.
`java.lang.String` `getRequestedSessionId()` Returns the session ID specified by the client.
`MessageBytes` `getRequestPathMB()` Get the request path.
`java.lang.String` `getRequestURI()` Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request.
`java.lang.StringBuffer` `getRequestURL()` Reconstructs the URL the client used to make the request.
`Response` `getResponse()`
`java.lang.String` `getScheme()` Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`.
`ServerCookies` `getServerCookies()` Return the server representation of the cookies associated with this request.
`java.lang.String` `getServerName()` Returns the host name of the server to which the request was sent.
`int` `getServerPort()` Returns the port number to which the request was sent.
`ServletContext` `getServletContext()`
`java.lang.String` `getServletPath()` Returns the part of this request's URL that calls the servlet.
`HttpSession` `getSession()` Returns the current session associated with this request, or if the request does not have a session, creates one.
`HttpSession` `getSession​(boolean create)` Returns the current `HttpSession` associated with this request or, if there is no current session and `create` is true, returns a new session.
`Session` `getSessionInternal()`
`Session` `getSessionInternal​(boolean create)`
`java.io.InputStream` `getStream()`
`protected B2CConverter` `getURIConverter()`
`java.security.Principal` `getUserPrincipal()` Returns a `java.security.Principal` object containing the name of the current authenticated user.
`Wrapper` `getWrapper()`
`boolean` `isAsync()`
`boolean` `isAsyncCompleting()`
`boolean` `isAsyncDispatching()`
`boolean` `isAsyncStarted()`
`boolean` `isAsyncSupported()`
`boolean` `isFinished()`
`boolean` `isParametersParsed()`
`boolean` `isRequestedSessionIdFromCookie()` Checks whether the requested session ID came in as a cookie.
`boolean` `isRequestedSessionIdFromUrl()` Deprecated. As of Version 2.1 of the Java Servlet API, use `isRequestedSessionIdFromURL()` instead.
`boolean` `isRequestedSessionIdFromURL()` Checks whether the requested session ID came in as part of the request URL.
`boolean` `isRequestedSessionIdValid()` Checks whether the requested session ID is still valid.
`boolean` `isSecure()` Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.
`boolean` `isUserInRole​(java.lang.String role)` Returns a boolean indicating whether the authenticated user is included in the specified logical "role".
`void` `login​(java.lang.String username, java.lang.String password)` Authenticate the provided user name and password and then associated the authenticated user with the request.
`void` `logout()` Removes any authenticated user from the request.
`ApplicationPushBuilder` `newPushBuilder()`
`ApplicationPushBuilder` `newPushBuilder​(HttpServletRequest request)`
`protected void` `parseCookies()` Parse cookies.
`protected void` `parseLocales()` Parse request locales.
`protected void` `parseLocalesHeader​(java.lang.String value, java.util.TreeMap<java.lang.Double,​java.util.ArrayList<java.util.Locale>> locales)` Parse accept-language header value.
`protected void` `parseParameters()` Parse request parameters.
`protected byte[]` `readChunkedPostBody()` Read chunked post body.
`protected int` `readPostBody​(byte[] body, int len)` Read post body in an array.
`void` `recycle()` Release all object references, and initialize instance variables, in preparation for reuse of this object.
`protected void` `recycleCookieInfo​(boolean recycleCoyote)`
`protected void` `recycleSessionInfo()`
`void` `removeAttribute​(java.lang.String name)` Remove the specified request attribute if it exists.
`void` `removeNote​(java.lang.String name)` Remove any object bound to the specified name in the internal notes for this request.
`void` `setAsyncSupported​(boolean asyncSupported)`
`void` `setAttribute​(java.lang.String name, java.lang.Object value)` Set the specified request attribute to the specified value.
`void` `setAuthType​(java.lang.String type)` Set the authentication type used for this request, if any; otherwise set the type to `null`.
`void` `setCharacterEncoding​(java.lang.String enc)` Overrides the name of the character encoding used in the body of this request.
`void` `setConnector​(Connector connector)` Set the Connector through which this Request was received.
`void` `setContentType​(java.lang.String contentType)` Set the content type for this Request.
`void` `setContext​(Context context)` Deprecated. Use setters on `MappingData` object.
`void` `setCoyoteRequest​(Request coyoteRequest)` Set the Coyote request.
`void` `setFilterChain​(FilterChain filterChain)` Set filter chain associated with the request.
`void` `setLocalPort​(int port)` Set the port number of the server to process this request.
`void` `setNote​(java.lang.String name, java.lang.Object value)` Bind an object to a specified name in the internal notes associated with this request, replacing any existing binding for this name.
`void` `setPathInfo​(java.lang.String path)` Set the path information for this Request.
`void` `setRemoteAddr​(java.lang.String remoteAddr)` Set the IP address of the remote client associated with this Request.
`void` `setRemoteHost​(java.lang.String remoteHost)` Set the fully qualified name of the remote client associated with this Request.
`void` `setRequest​(HttpServletRequest applicationRequest)` Set a wrapped HttpServletRequest to pass to the application.
`void` `setRequestedSessionCookie​(boolean flag)` Set a flag indicating whether or not the requested session ID for this request came in through a cookie.
`void` `setRequestedSessionId​(java.lang.String id)` Set the requested session ID for this request.
`void` `setRequestedSessionSSL​(boolean flag)` Set a flag indicating whether or not the requested session ID for this request came in through SSL.
`void` `setRequestedSessionURL​(boolean flag)` Set a flag indicating whether or not the requested session ID for this request came in through a URL.
`void` `setResponse​(Response response)` Set the Response with which this Request is associated.
`void` `setSecure​(boolean secure)` Set the value to be returned by `isSecure()` for this Request.
`void` `setServerPort​(int port)` Set the port number of the server to process this request.
`protected void` `setURIConverter​(B2CConverter URIConverter)` Set the URI converter.
`void` `setUserPrincipal​(java.security.Principal principal)` Set the Principal who has been authenticated for this Request.
`void` `setWrapper​(Wrapper wrapper)` Deprecated. Use setters on `MappingData` object.
`AsyncContext` `startAsync()`
`AsyncContext` `startAsync​(ServletRequest request, ServletResponse response)`
`protected java.lang.String` `unescape​(java.lang.String s)`
`<T extends HttpUpgradeHandler> T` `upgrade​(java.lang.Class<T> httpUpgradeHandlerClass)` Start the HTTP upgrade process and create and instance of the provided protocol handler class.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### coyoteRequest

    protected Request coyoteRequest

Coyote request.

#### GMT_ZONE

    @Deprecated
    protected static final java.util.TimeZone GMT_ZONE

Deprecated.
Unused. This will be removed in Tomcat 10.

#### sm

    protected static final StringManager sm

The string manager for this package.

#### cookies

    protected Cookie[] cookies

The set of cookies associated with this Request.

#### formats

    @Deprecated
    protected final java.text.SimpleDateFormat[] formats

Deprecated.
Unused. This will be removed in Tomcat 10
The set of SimpleDateFormat formats to use in getDateHeader(). Notice that because SimpleDateFormat is not thread-safe, we can't declare formats[] as a static variable.

#### defaultLocale

    protected static final java.util.Locale defaultLocale

The default Locale if none are specified.

#### sslAttributesParsed

    protected boolean sslAttributesParsed

Flag that indicates if SSL attributes have been parsed to improve performance for applications (usually frameworks) that make multiple calls to `getAttributeNames()`.

#### locales

    protected final java.util.ArrayList<java.util.Locale> locales

The preferred Locales associated with this Request.

#### authType

    protected java.lang.String authType

Authentication type.

#### internalDispatcherType

    protected DispatcherType internalDispatcherType

The current dispatcher type.

#### inputBuffer

    protected final InputBuffer inputBuffer

The associated input buffer.

#### inputStream

    protected CoyoteInputStream inputStream

ServletInputStream.

#### reader

    protected CoyoteReader reader

Reader.

#### usingInputStream

    protected boolean usingInputStream

Using stream flag.

#### usingReader

    protected boolean usingReader

Using reader flag.

#### userPrincipal

    protected java.security.Principal userPrincipal

User principal.

#### parametersParsed

    protected boolean parametersParsed

Request parameters parsed flag.

#### cookiesParsed

    protected boolean cookiesParsed

Cookie headers parsed flag. Indicates that the cookie headers have been parsed into ServerCookies.

#### cookiesConverted

    protected boolean cookiesConverted

Cookie parsed flag. Indicates that the ServerCookies have been converted into user facing Cookie objects.

#### secure

    protected boolean secure

Secure flag.

#### subject

    protected transient javax.security.auth.Subject subject

The Subject associated with the current AccessControlContext

#### CACHED_POST_LEN

    protected static final int CACHED_POST_LEN

Post data buffer.

See Also:
  Constant Field Values

#### postData

    protected byte[] postData

#### parameterMap

    protected ParameterMap<java.lang.String,​java.lang.String[]> parameterMap

Hash map used in the getParametersMap method.

#### parts

    protected java.util.Collection<Part> parts

The parts, if any, uploaded with this request.

#### partsParseException

    protected java.lang.Exception partsParseException

The exception thrown, if any when parsing the parts.

#### session

    protected Session session

The currently active session for this request.

#### requestDispatcherPath

    protected java.lang.Object requestDispatcherPath

The current request dispatcher path.

#### requestedSessionCookie

    protected boolean requestedSessionCookie

Was the requested session ID received in a cookie?

#### requestedSessionId

    protected java.lang.String requestedSessionId

The requested session ID (if any) for this request.

#### requestedSessionURL

    protected boolean requestedSessionURL

Was the requested session ID received in a URL?

#### requestedSessionSSL

    protected boolean requestedSessionSSL

Was the requested session ID obtained from the SSL session?

#### localesParsed

    protected boolean localesParsed

Parse locales.

#### localPort

    protected int localPort

Local port

#### remoteAddr

    protected java.lang.String remoteAddr

Remote address.

#### peerAddr

    protected java.lang.String peerAddr

Connection peer address.

#### remoteHost

    protected java.lang.String remoteHost

Remote host.

#### remotePort

    protected int remotePort

Remote port

#### localAddr

    protected java.lang.String localAddr

Local address

#### localName

    protected java.lang.String localName

Local address

#### asyncSupported

    protected java.lang.Boolean asyncSupported

#### connector

    protected Connector connector

Associated Catalina connector.

#### filterChain

    protected FilterChain filterChain

Filter chain associated with the request.

#### mappingData

    protected final MappingData mappingData

Mapping data.

#### facade

    protected RequestFacade facade

The facade associated with this request.

#### response

    protected Response response

The response with which this request is associated.

#### URIConverter

    protected B2CConverter URIConverter

URI byte to char converter.

### Constructor Detail

#### Request

    public Request()

### Method Detail

#### setCoyoteRequest

    public void setCoyoteRequest​(Request coyoteRequest)

Set the Coyote request.

Parameters:
  `coyoteRequest` - The Coyote request

#### getCoyoteRequest

    public Request getCoyoteRequest()

Get the Coyote request.

Returns:
  the Coyote request object

#### addPathParameter

    protected void addPathParameter​(java.lang.String name,
                                    java.lang.String value)

#### getPathParameter

    protected java.lang.String getPathParameter​(java.lang.String name)

#### setAsyncSupported

    public void setAsyncSupported​(boolean asyncSupported)

#### recycle

    public void recycle()

Release all object references, and initialize instance variables, in preparation for reuse of this object.

#### recycleSessionInfo

    protected void recycleSessionInfo()

#### recycleCookieInfo

    protected void recycleCookieInfo​(boolean recycleCoyote)

#### getConnector

    public Connector getConnector()

Returns:
  the Connector through which this Request was received.

#### setConnector

    public void setConnector​(Connector connector)

Set the Connector through which this Request was received.

Parameters:
  `connector` - The new connector

#### getContext

    public Context getContext()

Return the Context within which this Request is being processed.

This is available as soon as the appropriate Context is identified. Note that availability of a Context allows `getContextPath()` to return a value, and thus enables parsing of the request URI.

Returns:
  the Context mapped with the request

#### getDiscardFacades

    public boolean getDiscardFacades()

Get the recycling strategy of the facade objects.

Returns:
  the value of the flag as set on the connector, or `true` if no connector is associated with this request

#### setContext

    @Deprecated
    public void setContext​(Context context)

Deprecated.
Use setters on `MappingData` object. Depending on use case, you may need to update other `MappingData` fields as well, such as `contextSlashCount` and `host`.

Parameters:
  `context` - The newly associated Context

#### getFilterChain

    public FilterChain getFilterChain()

Get filter chain associated with the request.

Returns:
  the associated filter chain

#### setFilterChain

    public void setFilterChain​(FilterChain filterChain)

Set filter chain associated with the request.

Parameters:
  `filterChain` - new filter chain

#### getHost

    public Host getHost()

Returns:
  the Host within which this Request is being processed.

#### getMappingData

    public MappingData getMappingData()

Returns:
  mapping data.

#### getRequest

    public HttpServletRequest getRequest()

Returns:
  the `ServletRequest` for which this object is the facade. This method must be implemented by a subclass.

#### setRequest

    public void setRequest​(HttpServletRequest applicationRequest)

Set a wrapped HttpServletRequest to pass to the application. Components wishing to wrap the request should obtain the request via `getRequest()`, wrap it and then call this method with the wrapped request.

Parameters:
  `applicationRequest` - The wrapped request to pass to the application

#### getResponse

    public Response getResponse()

Returns:
  the Response with which this Request is associated.

#### setResponse

    public void setResponse​(Response response)

Set the Response with which this Request is associated.

Parameters:
  `response` - The new associated response

#### getStream

    public java.io.InputStream getStream()

Returns:
  the input stream associated with this Request.

#### getURIConverter

    protected B2CConverter getURIConverter()

Returns:
  the URI converter.

#### setURIConverter

    protected void setURIConverter​(B2CConverter URIConverter)

Set the URI converter.

Parameters:
  `URIConverter` - the new URI converter

#### getWrapper

    public Wrapper getWrapper()

Returns:
  the Wrapper within which this Request is being processed.

#### setWrapper

    @Deprecated
    public void setWrapper​(Wrapper wrapper)

Deprecated.
Use setters on `MappingData` object. Depending on use case, you may need to update other `MappingData` fields as well, such as `context` and `contextSlashCount`.

Parameters:
  `wrapper` - The newly associated Wrapper

#### createInputStream

    public ServletInputStream createInputStream()
                                         throws java.io.IOException

Create and return a ServletInputStream to read the content associated with this Request.

Returns:
  the created input stream
Throws:
  `java.io.IOException` - if an input/output error occurs

#### finishRequest

    public void finishRequest()
                       throws java.io.IOException

Perform whatever actions are required to flush and close the input stream or reader, in a single operation.

Throws:
  `java.io.IOException` - if an input/output error occurs

#### getNote

    public java.lang.Object getNote​(java.lang.String name)

Parameters:
  `name` - Name of the note to be returned
Returns:
  the object bound with the specified name to the internal notes for this request, or `null` if no such binding exists.

#### removeNote

    public void removeNote​(java.lang.String name)

Remove any object bound to the specified name in the internal notes for this request.

Parameters:
  `name` - Name of the note to be removed

#### setLocalPort

    public void setLocalPort​(int port)

Set the port number of the server to process this request.

Parameters:
  `port` - The server port

#### setNote

    public void setNote​(java.lang.String name,
                        java.lang.Object value)

Bind an object to a specified name in the internal notes associated with this request, replacing any existing binding for this name.

Parameters:
  `name` - Name to which the object should be bound
  `value` - Object to be bound to the specified name

#### setRemoteAddr

    public void setRemoteAddr​(java.lang.String remoteAddr)

Set the IP address of the remote client associated with this Request.

Parameters:
  `remoteAddr` - The remote IP address

#### setRemoteHost

    public void setRemoteHost​(java.lang.String remoteHost)

Set the fully qualified name of the remote client associated with this Request.

Parameters:
  `remoteHost` - The remote host name

#### setSecure

    public void setSecure​(boolean secure)

Set the value to be returned by `isSecure()` for this Request.

Parameters:
  `secure` - The new isSecure value

#### setServerPort

    public void setServerPort​(int port)

Set the port number of the server to process this request.

Parameters:
  `port` - The server port

#### getAttribute

    public java.lang.Object getAttribute​(java.lang.String name)

Description copied from interface: `javax.servlet.ServletRequest`
Returns the value of the named attribute as an `Object`, or `null` if no attribute of the given name exists.

Attributes can be set two ways. The servlet container may set attributes to make available custom information about a request. For example, for requests made using HTTPS, the attribute `javax.servlet.request.X509Certificate` can be used to retrieve information on the certificate of the client. Attributes can also be set programmatically using `ServletRequest.setAttribute(java.lang.String, java.lang.Object)`. This allows information to be embedded into a request before a `RequestDispatcher` call.

Attribute names should follow the same conventions as package names. Names beginning with `java.*` and `javax.*` are reserved for use by the Servlet specification. Names beginning with `sun.*`, `com.sun.*`, `oracle.*` and `com.oracle.*`) are reserved for use by Oracle Corporation.

Specified by:
  `getAttribute` in interface `ServletRequest`
Parameters:
  `name` - Name of the request attribute to return
Returns:
  the specified request attribute if it exists; otherwise, return `null`.

#### getContentLengthLong

    public long getContentLengthLong()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_LENGTH.

Specified by:
  `getContentLengthLong` in interface `ServletRequest`
Returns:
  a long integer containing the length of the request body or -1 if the length is not known

#### getAttributeNames

    public java.util.Enumeration<java.lang.String> getAttributeNames()

Return the names of all request attributes for this Request, or an empty `Enumeration` if there are none. Note that the attribute names returned will only be those for the attributes set via `setAttribute(String, Object)`. Tomcat internal attributes will not be included although they are accessible via `getAttribute(String)`. The Tomcat internal attributes include:

- `Globals.DISPATCHER_TYPE_ATTR`
- `Globals.DISPATCHER_REQUEST_PATH_ATTR`
- `Globals.ASYNC_SUPPORTED_ATTR`
- `Globals.CERTIFICATES_ATTR` (SSL connections only)
- `Globals.CIPHER_SUITE_ATTR` (SSL connections only)
- `Globals.KEY_SIZE_ATTR` (SSL connections only)
- `Globals.SSL_SESSION_ID_ATTR` (SSL connections only)
- `Globals.SSL_SESSION_MGR_ATTR` (SSL connections only)
- `Globals.PARAMETER_PARSE_FAILED_ATTR`

The underlying connector may also expose request attributes. These all have names starting with "org.apache.tomcat" and include:

- `Globals.SENDFILE_SUPPORTED_ATTR`

Connector implementations may return some, all or none of these attributes and may also support additional attributes.

Specified by:
  `getAttributeNames` in interface `ServletRequest`
Returns:
  the attribute names enumeration

#### getCharacterEncoding

    public java.lang.String getCharacterEncoding()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the name of the character encoding used in the body of this request. This method returns `null` if the request does not specify a character encoding

Specified by:
  `getCharacterEncoding` in interface `ServletRequest`
Returns:
  the character encoding for this Request.

#### getContentLength

    public int getContentLength()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the length, in bytes, of the request body and made available by the input stream, or -1 if the length is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_LENGTH.

Specified by:
  `getContentLength` in interface `ServletRequest`
Returns:
  the content length for this Request.

#### getContentType

    public java.lang.String getContentType()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the MIME type of the body of the request, or `null` if the type is not known. For HTTP servlets, same as the value of the CGI variable CONTENT_TYPE.

Specified by:
  `getContentType` in interface `ServletRequest`
Returns:
  the content type for this Request.

#### setContentType

    public void setContentType​(java.lang.String contentType)

Set the content type for this Request.

Parameters:
  `contentType` - The content type

#### getInputStream

    public ServletInputStream getInputStream()
                                      throws java.io.IOException

Description copied from interface: `javax.servlet.ServletRequest`
Retrieves the body of the request as binary data using a `ServletInputStream`. Either this method or `ServletRequest.getReader()` may be called to read the body, not both.

Specified by:
  `getInputStream` in interface `ServletRequest`
Returns:
  the servlet input stream for this Request. The default implementation returns a servlet input stream created by `createInputStream()`.
Throws:
  `java.lang.IllegalStateException` - if `getReader()` has already been called for this request
  `java.io.IOException` - if an input/output error occurs

#### getLocale

    public java.util.Locale getLocale()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the preferred `Locale` that the client will accept content in, based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns the default locale for the server.

Specified by:
  `getLocale` in interface `ServletRequest`
Returns:
  the preferred Locale that the client will accept content in, based on the value for the first `Accept-Language` header that was encountered. If the request did not specify a preferred language, the server's default Locale is returned.

#### getLocales

    public java.util.Enumeration<java.util.Locale> getLocales()

Description copied from interface: `javax.servlet.ServletRequest`
Returns an `Enumeration` of `Locale` objects indicating, in decreasing order starting with the preferred locale, the locales that are acceptable to the client based on the Accept-Language header. If the client request doesn't provide an Accept-Language header, this method returns an `Enumeration` containing one `Locale`, the default locale for the server.

Specified by:
  `getLocales` in interface `ServletRequest`
Returns:
  the set of preferred Locales that the client will accept content in, based on the values for any `Accept-Language` headers that were encountered. If the request did not specify a preferred language, the server's default Locale is returned.

#### getParameter

    public java.lang.String getParameter​(java.lang.String name)

Description copied from interface: `javax.servlet.ServletRequest`
Returns the value of a request parameter as a `String`, or `null` if the parameter does not exist. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

You should only use this method when you are sure the parameter has only one value. If the parameter might have more than one value, use `ServletRequest.getParameterValues(java.lang.String)`.

If you use this method with a multivalued parameter, the value returned is equal to the first value in the array returned by `getParameterValues`.

If the parameter data was sent in the request body, such as occurs with an HTTP POST request, then reading the body directly via `ServletRequest.getInputStream()` or `ServletRequest.getReader()` can interfere with the execution of this method.

Specified by:
  `getParameter` in interface `ServletRequest`
Parameters:
  `name` - Name of the desired request parameter
Returns:
  the value of the specified request parameter, if any; otherwise, return `null`. If there is more than one value defined, return only the first one.
See Also:
  `ServletRequest.getParameterValues(java.lang.String)`

#### getParameterMap

    public java.util.Map<java.lang.String,​java.lang.String[]> getParameterMap()

Returns a `Map` of the parameters of this request. Request parameters are extra information sent with the request. For HTTP servlets, parameters are contained in the query string or posted form data.

Specified by:
  `getParameterMap` in interface `ServletRequest`
Returns:
  A `Map` containing parameter names as keys and parameter values as map values.

#### getParameterNames

    public java.util.Enumeration<java.lang.String> getParameterNames()

Description copied from interface: `javax.servlet.ServletRequest`
Returns an `Enumeration` of `String` objects containing the names of the parameters contained in this request. If the request has no parameters, the method returns an empty `Enumeration`.

Specified by:
  `getParameterNames` in interface `ServletRequest`
Returns:
  the names of all defined request parameters for this request.

#### getParameterValues

    public java.lang.String[] getParameterValues​(java.lang.String name)

Description copied from interface: `javax.servlet.ServletRequest`
Returns an array of `String` objects containing all of the values the given request parameter has, or `null` if the parameter does not exist.

If the parameter has a single value, the array has a length of 1.

Specified by:
  `getParameterValues` in interface `ServletRequest`
Parameters:
  `name` - Name of the desired request parameter
Returns:
  the defined values for the specified request parameter, if any; otherwise, return `null`.
See Also:
  `ServletRequest.getParameter(java.lang.String)`

#### getProtocol

    public java.lang.String getProtocol()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the name and version of the protocol the request uses in the form protocol/majorVersion.minorVersion, for example, HTTP/1.1. For HTTP servlets, the value returned is the same as the value of the CGI variable `SERVER_PROTOCOL`.

Specified by:
  `getProtocol` in interface `ServletRequest`
Returns:
  the protocol and version used to make this Request.

#### getReader

    public java.io.BufferedReader getReader()
                                     throws java.io.IOException

Read the Reader wrapping the input stream for this Request. The default implementation wraps a `BufferedReader` around the servlet input stream returned by `createInputStream()`.

Specified by:
  `getReader` in interface `ServletRequest`
Returns:
  a buffered reader for the request
Throws:
  `java.lang.IllegalStateException` - if `getInputStream()` has already been called for this request
  `java.io.IOException` - if an input/output error occurs
See Also:
  `ServletRequest.getInputStream()`

#### getRealPath

    @Deprecated
    public java.lang.String getRealPath​(java.lang.String path)

Deprecated.
As of version 2.1 of the Java Servlet API, use `ServletContext.getRealPath()`.

Specified by:
  `getRealPath` in interface `ServletRequest`
Parameters:
  `path` - Path to be translated
Returns:
  the real path of the specified virtual path.

#### getRemoteAddr

    public java.lang.String getRemoteAddr()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the Internet Protocol (IP) address of the client or last proxy that sent the request. For HTTP servlets, same as the value of the CGI variable `REMOTE_ADDR`.

Specified by:
  `getRemoteAddr` in interface `ServletRequest`
Returns:
  the remote IP address making this Request.

#### getPeerAddr

    public java.lang.String getPeerAddr()

Returns:
  the connection peer IP address making this Request.

#### getRemoteHost

    public java.lang.String getRemoteHost()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the fully qualified name of the client or the last proxy that sent the request. If the engine cannot or chooses not to resolve the hostname (to improve performance), this method returns the dotted-string form of the IP address. For HTTP servlets, same as the value of the CGI variable `REMOTE_HOST`.

Specified by:
  `getRemoteHost` in interface `ServletRequest`
Returns:
  the remote host name making this Request.

#### getRemotePort

    public int getRemotePort()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the Internet Protocol (IP) source port of the client or last proxy that sent the request.

Specified by:
  `getRemotePort` in interface `ServletRequest`
Returns:
  the Internet Protocol (IP) source port of the client or last proxy that sent the request.

#### getLocalName

    public java.lang.String getLocalName()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the host name of the Internet Protocol (IP) interface on which the request was received.

Specified by:
  `getLocalName` in interface `ServletRequest`
Returns:
  the host name of the Internet Protocol (IP) interface on which the request was received.

#### getLocalAddr

    public java.lang.String getLocalAddr()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the Internet Protocol (IP) address of the interface on which the request was received.

Specified by:
  `getLocalAddr` in interface `ServletRequest`
Returns:
  the Internet Protocol (IP) address of the interface on which the request was received.

#### getLocalPort

    public int getLocalPort()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the Internet Protocol (IP) port number of the interface on which the request was received.

Specified by:
  `getLocalPort` in interface `ServletRequest`
Returns:
  the Internet Protocol (IP) port number of the interface on which the request was received.

#### getRequestDispatcher

    public RequestDispatcher getRequestDispatcher​(java.lang.String path)

Description copied from interface: `javax.servlet.ServletRequest`
Returns a `RequestDispatcher` object that acts as a wrapper for the resource located at the given path. A `RequestDispatcher` object can be used to forward a request to the resource or to include the resource in a response. The resource can be dynamic or static.

The pathname specified may be relative, although it cannot extend outside the current servlet context. If the path begins with a "/" it is interpreted as relative to the current context root. This method returns `null` if the servlet container cannot return a `RequestDispatcher`.

The difference between this method and `ServletContext.getRequestDispatcher(java.lang.String)` is that this method can take a relative path.

Specified by:
  `getRequestDispatcher` in interface `ServletRequest`
Parameters:
  `path` - Path of the resource to be wrapped
Returns:
  a RequestDispatcher that wraps the resource at the specified path, which may be interpreted as relative to the current request path.
See Also:
  `RequestDispatcher`, `ServletContext.getRequestDispatcher(java.lang.String)`

#### getScheme

    public java.lang.String getScheme()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the name of the scheme used to make this request, for example, `http`, `https`, or `ftp`. Different schemes have different rules for constructing URLs, as noted in RFC 1738.

Specified by:
  `getScheme` in interface `ServletRequest`
Returns:
  the scheme used to make this Request.

#### getServerName

    public java.lang.String getServerName()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the host name of the server to which the request was sent. It is the value of the part before ":" in the `Host` header value, if any, or the resolved server name, or the server IP address.

Specified by:
  `getServerName` in interface `ServletRequest`
Returns:
  the server name responding to this Request.

#### getServerPort

    public int getServerPort()

Description copied from interface: `javax.servlet.ServletRequest`
Returns the port number to which the request was sent. It is the value of the part after ":" in the `Host` header value, if any, or the server port where the client connection was accepted on.

Specified by:
  `getServerPort` in interface `ServletRequest`
Returns:
  the server port responding to this Request.

#### isSecure

    public boolean isSecure()

Description copied from interface: `javax.servlet.ServletRequest`
Returns a boolean indicating whether this request was made using a secure channel, such as HTTPS.

Specified by:
  `isSecure` in interface `ServletRequest`
Returns:
  `true` if this request was received on a secure connection.

#### removeAttribute

    public void removeAttribute​(java.lang.String name)

Remove the specified request attribute if it exists.

Specified by:
  `removeAttribute` in interface `ServletRequest`
Parameters:
  `name` - Name of the request attribute to remove

#### setAttribute

    public void setAttribute​(java.lang.String name,
                             java.lang.Object value)

Set the specified request attribute to the specified value.

Specified by:
  `setAttribute` in interface `ServletRequest`
Parameters:
  `name` - Name of the request attribute to set
  `value` - The associated value

#### setCharacterEncoding

    public void setCharacterEncoding​(java.lang.String enc)
                              throws java.io.UnsupportedEncodingException

Overrides the name of the character encoding used in the body of this request. This method must be called prior to reading request parameters or reading input using `getReader()`.

Specified by:
  `setCharacterEncoding` in interface `ServletRequest`
Parameters:
  `enc` - The character encoding to be used
Throws:
  `java.io.UnsupportedEncodingException` - if the specified encoding is not supported
Since:
  Servlet 2.3

#### getServletContext

    public ServletContext getServletContext()

Specified by:
  `getServletContext` in interface `ServletRequest`
Returns:
  TODO

#### startAsync

    public AsyncContext startAsync()

Specified by:
  `startAsync` in interface `ServletRequest`
Returns:
  TODO

#### startAsync

    public AsyncContext startAsync​(ServletRequest request,
                                   ServletResponse response)

Specified by:
  `startAsync` in interface `ServletRequest`
Parameters:
  `request` - The ServletRequest with which to initialise the asynchronous context
  `response` - The ServletResponse with which to initialise the asynchronous context
Returns:
  TODO

#### isAsyncStarted

    public boolean isAsyncStarted()

Specified by:
  `isAsyncStarted` in interface `ServletRequest`
Returns:
  TODO

#### isAsyncDispatching

    public boolean isAsyncDispatching()

#### isAsyncCompleting

    public boolean isAsyncCompleting()

#### isAsync

    public boolean isAsync()

#### isAsyncSupported

    public boolean isAsyncSupported()

Specified by:
  `isAsyncSupported` in interface `ServletRequest`
Returns:
  TODO

#### getAsyncContext

    public AsyncContext getAsyncContext()

Description copied from interface: `javax.servlet.ServletRequest`
Get the current AsyncContext.

Specified by:
  `getAsyncContext` in interface `ServletRequest`
Returns:
  The current AsyncContext

#### getAsyncContextInternal

    public AsyncContextImpl getAsyncContextInternal()

#### getDispatcherType

    public DispatcherType getDispatcherType()

Specified by:
  `getDispatcherType` in interface `ServletRequest`
Returns:
  TODO

#### addCookie

    public void addCookie​(Cookie cookie)

Add a Cookie to the set of Cookies associated with this Request.

Parameters:
  `cookie` - The new cookie

#### addLocale

    public void addLocale​(java.util.Locale locale)

Add a Locale to the set of preferred Locales for this Request. The first added Locale will be the first one returned by getLocales().

Parameters:
  `locale` - The new preferred Locale

#### clearCookies

    public void clearCookies()

Clear the collection of Cookies associated with this Request.

#### clearLocales

    public void clearLocales()

Clear the collection of Locales associated with this Request.

#### setAuthType

    public void setAuthType​(java.lang.String type)

Set the authentication type used for this request, if any; otherwise set the type to `null`. Typical values are "BASIC", "DIGEST", or "SSL".

Parameters:
  `type` - The authentication type used

#### setPathInfo

    public void setPathInfo​(java.lang.String path)

Set the path information for this Request. This will normally be called when the associated Context is mapping the Request to a particular Wrapper.

Parameters:
  `path` - The path information

#### setRequestedSessionCookie

    public void setRequestedSessionCookie​(boolean flag)

Set a flag indicating whether or not the requested session ID for this request came in through a cookie. This is normally called by the HTTP Connector, when it parses the request headers.

Parameters:
  `flag` - The new flag

#### setRequestedSessionId

    public void setRequestedSessionId​(java.lang.String id)

Set the requested session ID for this request. This is normally called by the HTTP Connector, when it parses the request headers.

Parameters:
  `id` - The new session id

#### setRequestedSessionURL

    public void setRequestedSessionURL​(boolean flag)

Set a flag indicating whether or not the requested session ID for this request came in through a URL. This is normally called by the HTTP Connector, when it parses the request headers.

Parameters:
  `flag` - The new flag

#### setRequestedSessionSSL

    public void setRequestedSessionSSL​(boolean flag)

Set a flag indicating whether or not the requested session ID for this request came in through SSL. This is normally called by the HTTP Connector, when it parses the request headers.

Parameters:
  `flag` - The new flag

#### getDecodedRequestURI

    public java.lang.String getDecodedRequestURI()

Get the decoded request URI.

Returns:
  the URL decoded request URI

#### getDecodedRequestURIMB

    public MessageBytes getDecodedRequestURIMB()

Get the decoded request URI.

Returns:
  the URL decoded request URI

#### setUserPrincipal

    public void setUserPrincipal​(java.security.Principal principal)

Set the Principal who has been authenticated for this Request. This value is also used to calculate the value to be returned by the `getRemoteUser()` method.

Parameters:
  `principal` - The user Principal

#### newPushBuilder

    public ApplicationPushBuilder newPushBuilder()

#### newPushBuilder

    public ApplicationPushBuilder newPushBuilder​(HttpServletRequest request)

#### upgrade

    public <T extends HttpUpgradeHandler> T upgrade​(java.lang.Class<T> httpUpgradeHandlerClass)
                                             throws java.io.IOException,
                                                    ServletException

Start the HTTP upgrade process and create and instance of the provided protocol handler class. The connection will be passed this instance once the current request/response pair has completed processing. Calling this method sets the response status to `HttpServletResponse.SC_SWITCHING_PROTOCOLS`.

Specified by:
  `upgrade` in interface `HttpServletRequest`
Type Parameters:
  `T` - The type of the upgrade handler
Parameters:
  `httpUpgradeHandlerClass` - The class that implements the upgrade handler
Returns:
  A newly created instance of the specified upgrade handler type
Throws:
  `java.io.IOException` - if an I/O error occurred during the upgrade
  `ServletException` - if the given httpUpgradeHandlerClass fails to be instantiated
Since:
  Servlet 3.1

#### getAuthType

    public java.lang.String getAuthType()

Return the authentication type used for this Request.

Specified by:
  `getAuthType` in interface `HttpServletRequest`
Returns:
  one of the static members BASIC_AUTH, FORM_AUTH, CLIENT_CERT_AUTH, DIGEST_AUTH (suitable for == comparison) or the container-specific string indicating the authentication scheme, or `null` if the request was not authenticated.

#### getContextPath

    public java.lang.String getContextPath()

Return the portion of the request URI used to select the Context of the Request. The value returned is not decoded which also implies it is not normalised.

Specified by:
  `getContextPath` in interface `HttpServletRequest`
Returns:
  a `String` specifying the portion of the request URI that indicates the context of the request

#### getCookies

    public Cookie[] getCookies()

Return the set of Cookies received with this Request. Triggers parsing of the Cookie HTTP headers followed by conversion to Cookie objects if this has not already been performed.

Specified by:
  `getCookies` in interface `HttpServletRequest`
Returns:
  the array of cookies

#### getServerCookies

    public ServerCookies getServerCookies()

Return the server representation of the cookies associated with this request. Triggers parsing of the Cookie HTTP headers (but not conversion to Cookie objects) if the headers have not yet been parsed.

Returns:
  the server cookies

#### getDateHeader

    public long getDateHeader​(java.lang.String name)

Return the value of the specified date header, if any; otherwise return -1.

Specified by:
  `getDateHeader` in interface `HttpServletRequest`
Parameters:
  `name` - Name of the requested date header
Returns:
  the date as a long
Throws:
  `java.lang.IllegalArgumentException` - if the specified header value cannot be converted to a date

#### getHeader

    public java.lang.String getHeader​(java.lang.String name)

Return the first value of the specified header, if any; otherwise, return `null`

Specified by:
  `getHeader` in interface `HttpServletRequest`
Parameters:
  `name` - Name of the requested header
Returns:
  the header value

#### getHeaders

    public java.util.Enumeration<java.lang.String> getHeaders​(java.lang.String name)

Return all of the values of the specified header, if any; otherwise, return an empty enumeration.

Specified by:
  `getHeaders` in interface `HttpServletRequest`
Parameters:
  `name` - Name of the requested header
Returns:
  the enumeration with the header values

#### getHeaderNames

    public java.util.Enumeration<java.lang.String> getHeaderNames()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns an enumeration of all the header names this request contains. If the request has no headers, this method returns an empty enumeration.

Some servlet containers do not allow servlets to access headers using this method, in which case this method returns `null`

Specified by:
  `getHeaderNames` in interface `HttpServletRequest`
Returns:
  the names of all headers received with this request.

#### getIntHeader

    public int getIntHeader​(java.lang.String name)

Return the value of the specified header as an integer, or -1 if there is no such header for this request.

Specified by:
  `getIntHeader` in interface `HttpServletRequest`
Parameters:
  `name` - Name of the requested header
Returns:
  the header value as an int
Throws:
  `java.lang.IllegalArgumentException` - if the specified header value cannot be converted to an integer

#### getHttpServletMapping

    public ApplicationMappingImpl getHttpServletMapping()

#### getMethod

    public java.lang.String getMethod()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns the name of the HTTP method with which this request was made, for example, GET, POST, or PUT. Same as the value of the CGI variable REQUEST_METHOD.

Specified by:
  `getMethod` in interface `HttpServletRequest`
Returns:
  the HTTP request method used in this Request.

#### getPathInfo

    public java.lang.String getPathInfo()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns any extra path information associated with the URL the client sent when it made this request. The extra path information follows the servlet path but precedes the query string and will start with a "/" character.

This method returns `null` if there was no extra path information.

Same as the value of the CGI variable PATH_INFO.

Specified by:
  `getPathInfo` in interface `HttpServletRequest`
Returns:
  the path information associated with this Request.

#### getPathTranslated

    public java.lang.String getPathTranslated()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns any extra path information after the servlet name but before the query string, and translates it to a real path. Same as the value of the CGI variable PATH_TRANSLATED.

If the URL does not have any extra path information, this method returns `null` or the servlet container cannot translate the virtual path to a real path for any reason (such as when the web application is executed from an archive). The web container does not decode this string.

Specified by:
  `getPathTranslated` in interface `HttpServletRequest`
Returns:
  the extra path information for this request, translated to a real path.

#### getQueryString

    public java.lang.String getQueryString()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns the query string that is contained in the request URL after the path. This method returns `null` if the URL does not have a query string. Same as the value of the CGI variable QUERY_STRING.

Specified by:
  `getQueryString` in interface `HttpServletRequest`
Returns:
  the query string associated with this request.

#### getRemoteUser

    public java.lang.String getRemoteUser()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns the login of the user making this request, if the user has been authenticated, or `null` if the user has not been authenticated. Whether the user name is sent with each subsequent request depends on the browser and type of authentication. Same as the value of the CGI variable REMOTE_USER.

Specified by:
  `getRemoteUser` in interface `HttpServletRequest`
Returns:
  the name of the remote user that has been authenticated for this Request.

#### getRequestPathMB

    public MessageBytes getRequestPathMB()

Get the request path.

Returns:
  the request path

#### getRequestedSessionId

    public java.lang.String getRequestedSessionId()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns the session ID specified by the client. This may not be the same as the ID of the current valid session for this request. If the client did not specify a session ID, this method returns `null`.

Specified by:
  `getRequestedSessionId` in interface `HttpServletRequest`
Returns:
  the session identifier included in this request, if any.
See Also:
  `HttpServletRequest.isRequestedSessionIdValid()`

#### getRequestURI

    public java.lang.String getRequestURI()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns the part of this request's URL from the protocol name up to the query string in the first line of the HTTP request. The web container does not decode this String. For example:

Examples of Returned Values
First line of HTTP request | Returned Value
--- | ---
POST /some/path.html HTTP/1.1 |  | /some/path.html
GET http://foo.bar/a.html HTTP/1.0 |  | /a.html
HEAD /xyz?a=b HTTP/1.1 |  | /xyz

To reconstruct a URL with a scheme and host, use `HttpServletRequest.getRequestURL()`.

Specified by:
  `getRequestURI` in interface `HttpServletRequest`
Returns:
  the request URI for this request.
See Also:
  `HttpServletRequest.getRequestURL()`

#### getRequestURL

    public java.lang.StringBuffer getRequestURL()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Reconstructs the URL the client used to make the request. The returned URL contains a protocol, server name, port number, and server path, but it does not include query string parameters.

Because this method returns a `StringBuffer`, not a string, you can modify the URL easily, for example, to append query parameters.

This method is useful for creating redirect messages and for reporting errors.

Specified by:
  `getRequestURL` in interface `HttpServletRequest`
Returns:
  a `StringBuffer` object containing the reconstructed URL

#### getServletPath

    public java.lang.String getServletPath()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns the part of this request's URL that calls the servlet. This path starts with a "/" character and includes either the servlet name or a path to the servlet, but does not include any extra path information or a query string. Same as the value of the CGI variable SCRIPT_NAME.

This method will return an empty string ("") if the servlet used to process this request was matched using the "/*" pattern.

Specified by:
  `getServletPath` in interface `HttpServletRequest`
Returns:
  the portion of the request URI used to select the servlet that will process this request.

#### getSession

    public HttpSession getSession()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns the current session associated with this request, or if the request does not have a session, creates one.

Specified by:
  `getSession` in interface `HttpServletRequest`
Returns:
  the session associated with this Request, creating one if necessary.
See Also:
  `HttpServletRequest.getSession(boolean)`

#### getSession

    public HttpSession getSession​(boolean create)

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns the current `HttpSession` associated with this request or, if there is no current session and `create` is true, returns a new session.

If `create` is `false` and the request has no valid `HttpSession`, this method returns `null`.

To make sure the session is properly maintained, you must call this method before the response is committed. If the container is using cookies to maintain session integrity and is asked to create a new session when the response is committed, an IllegalStateException is thrown.

Specified by:
  `getSession` in interface `HttpServletRequest`
Parameters:
  `create` - Create a new session if one does not exist
Returns:
  the session associated with this Request, creating one if necessary and requested.
See Also:
  `HttpServletRequest.getSession()`

#### isRequestedSessionIdFromCookie

    public boolean isRequestedSessionIdFromCookie()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Checks whether the requested session ID came in as a cookie.

Specified by:
  `isRequestedSessionIdFromCookie` in interface `HttpServletRequest`
Returns:
  `true` if the session identifier included in this request came from a cookie.
See Also:
  `HttpServletRequest.getSession(boolean)`

#### isRequestedSessionIdFromURL

    public boolean isRequestedSessionIdFromURL()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Checks whether the requested session ID came in as part of the request URL.

Specified by:
  `isRequestedSessionIdFromURL` in interface `HttpServletRequest`
Returns:
  `true` if the session identifier included in this request came from the request URI.
See Also:
  `HttpServletRequest.getSession(boolean)`

#### isRequestedSessionIdFromUrl

    @Deprecated
    public boolean isRequestedSessionIdFromUrl()

Deprecated.
As of Version 2.1 of the Java Servlet API, use `isRequestedSessionIdFromURL()` instead.

Specified by:
  `isRequestedSessionIdFromUrl` in interface `HttpServletRequest`
Returns:
  `true` if the session identifier included in this request came from the request URI.

#### isRequestedSessionIdValid

    public boolean isRequestedSessionIdValid()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Checks whether the requested session ID is still valid.

Specified by:
  `isRequestedSessionIdValid` in interface `HttpServletRequest`
Returns:
  `true` if the session identifier included in this request identifies a valid session.
See Also:
  `HttpServletRequest.getRequestedSessionId()`, `HttpServletRequest.getSession(boolean)`

#### isUserInRole

    public boolean isUserInRole​(java.lang.String role)

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns a boolean indicating whether the authenticated user is included in the specified logical "role". Roles and role membership can be defined using deployment descriptors. If the user has not been authenticated, the method returns `false`.

Specified by:
  `isUserInRole` in interface `HttpServletRequest`
Parameters:
  `role` - Role name to be validated
Returns:
  `true` if the authenticated user principal possesses the specified role name.

#### getPrincipal

    public java.security.Principal getPrincipal()

Returns:
  the principal that has been authenticated for this Request.

#### getUserPrincipal

    public java.security.Principal getUserPrincipal()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Returns a `java.security.Principal` object containing the name of the current authenticated user. If the user has not been authenticated, the method returns `null`.

Specified by:
  `getUserPrincipal` in interface `HttpServletRequest`
Returns:
  the principal that has been authenticated for this Request.

#### getSessionInternal

    public Session getSessionInternal()

Returns:
  the session associated with this Request, creating one if necessary.

#### changeSessionId

    public void changeSessionId​(java.lang.String newSessionId)

Change the ID of the session that this request is associated with. There are several things that may trigger an ID change. These include moving between nodes in a cluster and session fixation prevention during the authentication process.

Parameters:
  `newSessionId` - The session to change the session ID for

#### changeSessionId

    public java.lang.String changeSessionId()

Description copied from interface: `javax.servlet.http.HttpServletRequest`
Changes the session ID of the session associated with this request. This method does not create a new session object it only changes the ID of the current session.

Specified by:
  `changeSessionId` in interface `HttpServletRequest`
Returns:
  the new session ID allocated to the session
See Also:
  `HttpSessionIdListener`

#### getSessionInternal

    public Session getSessionInternal​(boolean create)

Parameters:
  `create` - Create a new session if one does not exist
Returns:
  the session associated with this Request, creating one if necessary and requested.

#### isParametersParsed

    public boolean isParametersParsed()

Returns:
  `true` if we have parsed parameters

#### isFinished

    public boolean isFinished()

Returns:
  `true` if an attempt has been made to read the request body and all of the request body has been read.

#### checkSwallowInput

    protected void checkSwallowInput()

Check the configuration for aborted uploads and if configured to do so, disable the swallowing of any remaining input and close the connection once the response has been written.

#### authenticate

    public boolean authenticate​(HttpServletResponse response)
                         throws java.io.IOException,
                                ServletException

Triggers the same authentication process as would be triggered if the request is for a resource that is protected by a security constraint.

Specified by:
  `authenticate` in interface `HttpServletRequest`
Parameters:
  `response` - The response to use to return any authentication challenge
Returns:
  `true` if the user is successfully authenticated and `false` if not
Throws:
  `java.io.IOException` - if the authentication process attempted to read from the request or write to the response and an I/O error occurred
  `ServletException` - if the authentication failed and the caller is expected to handle the failure

#### login

    public void login​(java.lang.String username,
                      java.lang.String password)
               throws ServletException

Authenticate the provided user name and password and then associated the authenticated user with the request.

Specified by:
  `login` in interface `HttpServletRequest`
Parameters:
  `username` - The user name to authenticate
  `password` - The password to use to authenticate the user
Throws:
  `ServletException` - If any of `HttpServletRequest.getRemoteUser()`, `HttpServletRequest.getUserPrincipal()` or `HttpServletRequest.getAuthType()` are non-null, if the configured authenticator does not support user name and password authentication or if the authentication fails

#### logout

    public void logout()
                throws ServletException

Removes any authenticated user from the request.

Specified by:
  `logout` in interface `HttpServletRequest`
Throws:
  `ServletException` - If the logout fails

#### getParts

    public java.util.Collection<Part> getParts()
                                        throws java.io.IOException,
                                               java.lang.IllegalStateException,
                                               ServletException

Return a collection of all uploaded Parts.

Specified by:
  `getParts` in interface `HttpServletRequest`
Returns:
  A collection of all uploaded Parts.
Throws:
  `java.io.IOException` - if an I/O error occurs
  `java.lang.IllegalStateException` - if size limits are exceeded or no multipart configuration is provided
  `ServletException` - if the request is not multipart/form-data

#### getPart

    public Part getPart​(java.lang.String name)
                 throws java.io.IOException,
                        java.lang.IllegalStateException,
                        ServletException

Gets the named Part or null if the Part does not exist. Triggers upload of all Parts.

Specified by:
  `getPart` in interface `HttpServletRequest`
Parameters:
  `name` - The name of the Part to obtain
Returns:
  The named Part or null if the Part does not exist
Throws:
  `java.io.IOException` - if an I/O error occurs
  `java.lang.IllegalStateException` - if size limits are exceeded
  `ServletException` - if the request is not multipart/form-data

#### doGetSession

    protected Session doGetSession​(boolean create)

#### unescape

    protected java.lang.String unescape​(java.lang.String s)

#### parseCookies

    protected void parseCookies()

Parse cookies. This only parses the cookies into the memory efficient ServerCookies structure. It does not populate the Cookie objects.

#### convertCookies

    protected void convertCookies()

Converts the parsed cookies (parsing the Cookie headers first if they have not been parsed) into Cookie objects.

#### parseParameters

    protected void parseParameters()

Parse request parameters.

#### readPostBody

    protected int readPostBody​(byte[] body,
                               int len)
                        throws java.io.IOException

Read post body in an array.

Parameters:
  `body` - The bytes array in which the body will be read
  `len` - The body length
Returns:
  the bytes count that has been read
Throws:
  `java.io.IOException` - if an IO exception occurred

#### readChunkedPostBody

    protected byte[] readChunkedPostBody()
                                  throws java.io.IOException

Read chunked post body.

Returns:
  the post body as a bytes array
Throws:
  `java.io.IOException` - if an IO exception occurred

#### parseLocales

    protected void parseLocales()

Parse request locales.

#### parseLocalesHeader

    protected void parseLocalesHeader​(java.lang.String value,
                                      java.util.TreeMap<java.lang.Double,​java.util.ArrayList<java.util.Locale>> locales)

Parse accept-language header value.

Parameters:
  `value` - the header value
  `locales` - the map that will hold the result